$If WINDOWS Then
$Else
    $ScreenHide
    $Console
    _Source _Console
    _Dest _Console
$End If


Type BMXHeaderType
    id As String * 3
    ver As _Unsigned _Byte
    Bits As _Unsigned _Byte
    VeraReg As _Unsigned _Byte
    Width As Integer
    Height As Integer
    PalUsed As _Unsigned _Byte
    PalStart As _Unsigned _Byte
    DataStart As _Unsigned Integer
    Compressed As _Byte
    VERABorder As _Unsigned _Byte
    Reserved As String * 16
End Type

Type VPALTYPE
    GB As _Unsigned _Byte
    R As _Unsigned _Byte
End Type


Dim Shared Fcount
Dim Shared wid
Dim Shared hei
Dim Shared Show&, Show2&
ReDim Shared ImageData(0) As _Unsigned _Byte
Dim Shared BMXName$
Dim Shared VERAPAL(0 To 255) As VPALTYPE
ChDir _StartDir$

main:
CFlag = 0

If Command$ <> "" Then
    FName$ = Command$(1)
    CFlag = -1
End If

If _CommandCount > 1 Then
    For I = 2 To _CommandCount
        FName$ = FName$ + "|" + Command$(I)
    Next I
End If


main2:
If FName$ = "" Then
    FName$ = _OpenFileDialog$("Select BMX Image file", "", "*.BMX|*.bmx", "BMX Files", -1)
    If FName$ = "" Then System
End If

Fcount = 0

MultiLoop:

DivPos = InStr(FName$, "|")

If DivPos <> 0 Then
    Fcount = Fcount + 1
    INIMG$ = Left$(FName$, DivPos - 1)
    FName$ = Right$(FName$, Len(FName$) - DivPos)
    Doit INIMG$
    Showit
    _MessageBox "Next BMX File", "OK to Proceed", "info"
    GoTo MultiLoop
End If

Fcount = Fcount + 1
Doit FName$
Showit

_MessageBox "DONE", "OK TO CLOSE", "info"

Screen 0
_FreeImage Show&

System

Function VERA2RGB& (Vpal As VPALTYPE)
    grn = Int(Vpal.GB / 16) * 16
    VERA2RGB = _RGB32(Vpal.R * 16, grn, (Vpal.GB - grn) * 16, 255)
End Function


Sub Showit
    Static InShow
    If InShow Then
        Screen 0
        _ScreenHide
        _FreeImage Show&
    End If
    $If WINDOWS Then
    $Else
        _ScreenShow
        _Dest _Console
    $End If
    Show& = _NewImage(wid * 2, hei * 2, 32)
    Show2& = _NewImage(wid, hei, 32)
    Screen Show2&
    _ScreenHide
    PixIndx& = 0
    For Y = 0 To (hei - 1)
        For X = 0 To (wid - 1)
            PSet (X, Y), VERA2RGB(VERAPAL(ImageData(PixIndx&)))
            PixIndx& = PixIndx& + 1
        Next X
    Next Y
    _PutImage , Show2&, Show&
    Screen Show&
    $If WINDOWS Then
    $Else
        _Dest _Console
    $End If
    _Title BMXName$
    _ScreenShow
    $If WINDOWS Then
    $Else
        _Dest _Console
    $End If
    _FreeImage Show2&
End Sub

Sub Doit (ImgFile$)
    Dim BmxHeader As BMXHeaderType
    If Not _FileExists(ImgFile$) Then
        _MessageBox "NOT FOUND", ImgFile$ + " NOT FOUND!", "error"
        Print
        BadFile = -1
        Exit Sub
    End If
    BMXName$ = GetFileName(ImgFile$) + GetFileExt(ImgFile$)
    Open ImgFile$ For Binary As #1

    Get #1, , BmxHeader
    If BmxHeader.id <> "BMX" Then
        Print "Not a BMX File"
        Exit Sub
    End If
    If BmxHeader.ver <> 1 Then
        Print "Version: "; BmxHeader.ver; "NOT SUPPORTED"
        Exit Sub
    End If
    If BmxHeader.Bits <> 8 Then
        Print "Bit Depth: "; BmxHeader.Bits; " NOT SUPPORTED"
        Exit Sub
    End If
    If BmxHeader.Compressed <> 0 Then
        Print "Compressed BMX's are NOT SUPPORTED"
        Exit Sub
    End If
    wid = BmxHeader.Width
    hei = BmxHeader.Height
    ImageSize& = wid * hei
    ReDim ImageData(0 To (ImageSize& - 1)) As _Unsigned _Byte
    If BmxHeader.PalUsed = 0 Then
        used = 256
    Else
        used = BmxHeader.PalUsed
    End If
    PALSize = used * 2
    PalEnd = (BmxHeader.PalStart + used) - 1
    ReDim PALDATA(BmxHeader.PalStart To PalEnd) As VPALTYPE
    Get #1, , PALDATA()
    For i = BmxHeader.PalStart To PalEnd
        VERAPAL(i) = PALDATA(i)
    Next i

    Get #1, , ImageData()
    Close #1

End Sub

Function GetFileExt$ (FName$)
    DOT$ = "."
    L = Len(FName$)
    TMP$ = ""
    If InStr(1, FName$, DOT$) = 0 Then GoTo Skipall
    For I = L To 1 Step -1
        C$ = Mid$(FName$, I, 1)
        TMP$ = C$ + TMP$
        If C$ = DOT$ Then Exit For
    Next I
    Skipall:
    GetFileExt = TMP$
End Function

Function GetFileName$ (FName$)
    $If WINDOWS Then
        SLASH$ = "\"
    $Else
        SLASH$ = "/"
    $End If

    TMP$ = ""
    T$ = GetFileExt(FName$)
    CUT = Len(T$)
    L = Len(FName$)
    TName$ = Left$(FName$, L - CUT)
    If InStr(1, TName$, SLASH$) = 0 Then
        TMP$ = TName$
        GoTo Skiploop
    End If
    For I = Len(TName$) To 1 Step -1
        C$ = Mid$(TName$, I, 1)
        If C$ <> SLASH$ Then
            TMP$ = C$ + TMP$
        Else
            Exit For
        End If
    Next I
    Skiploop:
    GetFileName = TMP$
End Function

Function GetFilePath$ (FName$)
    t1$ = GetFileExt(FName$)
    t2$ = GetFileName(FName$)
    L = Len(FName$) - (Len(t1$) + Len(t2$))
    GetFilePath$ = Left$(FName$, L)
End Function



